=== debian/changelog ===
ros-galactic-webots-ros2-driver (2022.1.4-1focal) focal; urgency=high

  * Fix the camera focal length in the CameraInfo topic.
  * Update the calculation of CameraRecognitionObject messages to the RDF convention of R2022b.

 -- Cyberbotics <support@cyberbotics.com>  Thu, 17 Nov 2022 23:00:00 -0000

ros-galactic-webots-ros2-driver (2022.1.3-1focal) focal; urgency=high

  * Added macOS support.

 -- Cyberbotics <support@cyberbotics.com>  Tue, 01 Nov 2022 23:00:00 -0000

ros-galactic-webots-ros2-driver (2022.1.2-1focal) focal; urgency=high

  * Fix issue where relatively defined PROTO were not found.
  * Added WSL support.

 -- Cyberbotics <support@cyberbotics.com>  Thu, 20 Oct 2022 22:00:00 -0000

ros-galactic-webots-ros2-driver (2022.1.1-1focal) focal; urgency=high

  * Simplified the detection of Webots installation folder.

 -- Cyberbotics <support@cyberbotics.com>  Mon, 10 Oct 2022 22:00:00 -0000

ros-galactic-webots-ros2-driver (2022.1.0-1focal) focal; urgency=high

  * Added an URDF importer feature to spawn robots from URDF files.

 -- Cyberbotics <support@cyberbotics.com>  Thu, 22 Sep 2022 22:00:00 -0000

ros-galactic-webots-ros2-driver (1.2.3-1focal) focal; urgency=high

  * Add option to set 'robot_description' parameter for 'robot_state_publisher' node.
  * Fix recognition camera.
  * Add a 'PointCloud2' publisher for the 'RangeFinder' device.

 -- Cyberbotics <support@cyberbotics.com>  Sun, 29 May 2022 22:00:00 -0000

ros-galactic-webots-ros2-driver (1.2.2-1focal) focal; urgency=high

  * Fix the Supervisor API access from plugins.

 -- Cyberbotics <support@cyberbotics.com>  Tue, 18 Jan 2022 23:00:00 -0000

ros-galactic-webots-ros2-driver (1.2.1-1focal) focal; urgency=high

  * Fix link error for 'webots_ros2_control' on macOS.
  * Fix lidar device according to FLU convention.

 -- Cyberbotics <support@cyberbotics.com>  Sun, 09 Jan 2022 23:00:00 -0000

ros-galactic-webots-ros2-driver (1.2.0-1focal) focal; urgency=high

  * Adapt the worlds to the new R2022a FLU convention.
  * Remove a double webots_ros2_driver header installation.
  * Add the publication of the 'gps/speed_vector' topic to the GPS ROS 2 device.

 -- Cyberbotics <support@cyberbotics.com>  Mon, 20 Dec 2021 23:00:00 -0000

ros-galactic-webots-ros2-driver (1.1.2-1focal) focal; urgency=high

  * Adapted the 'webots_ros2_driver' package to be also a python alternative to the 'webots_ros2_core' package.

 -- Cyberbotics <support@cyberbotics.com>  Tue, 02 Nov 2021 23:00:00 -0000

ros-galactic-webots-ros2-driver (1.1.0-1focal) focal; urgency=high

  * Initial version

 -- Cyberbotics <support@cyberbotics.com>  Sun, 18 Jul 2021 22:00:00 -0000
